## ardour 8.12.0+ds

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import subprocess
import sys
import platform as PLATFORM
from waflib.Build import BuildContext
import waflib.Utils as Utils

# Fixup OSX 10.5/10.6 builds
# prefer gcc, g++ 4.x over ancient clang-1.5
from waflib.Tools.compiler_c import c_compiler
from waflib.Tools.compiler_cxx import cxx_compiler
c_compiler['darwin'] = ['gcc', 'clang' ]
cxx_compiler['darwin'] = ['g++', 'clang++' ]

class i18n(BuildContext):
    cmd = 'i18n'
    fun = 'i18n'

class i18n_pot(BuildContext):
    cmd = 'i18n_pot'
    fun = 'i18n_pot'

class i18n_po(BuildContext):
    cmd = 'i18n_po'
    fun = 'i18n_po'

class i18n_mo(BuildContext):
    cmd = 'i18n_mo'
    fun = 'i18n_mo'

compiler_flags_dictionaries= {
    'gcc' : {
        # Flags required when building a debug build
        'debuggable' : [ '-g' ],
        # Flags required for the linker (if any) when building a debug build
        'linker-debuggable' : '',
        # Flags required when building a non-debug optimized build
        'nondebuggable' : '-DNDEBUG',
        # Flags required to enable profiling at runtime with optimized builds
        'profile' : [ '-fno-omit-frame-pointer' ],
        # Flags required to enable gprofile profiling
        'gprofile' : '-pg',
        # Flags required to disable warnings about unused arguments to function calls
        'silence-unused-arguments' : '',
        # Flags required to use SSE unit for general math
        'sse' : '-msse',
        # Flags required to use SSE unit for floating point math
        'fpmath-sse' : '-mfpmath=sse',
        # Flags required to use _xgetbv with mingw+gcc > 8.2
        'xsaveintrin' : '-mxsave',
        # Flags required to use XMM Intrinsics
        'xmmintrinsics' : '-DUSE_XMMINTRIN',
        # Flags to use posix pipes between compiler stages
        'pipe' : '-pipe',
        # Flags for maximally optimized build
        'full-optimization' : [ '-O3', '-fomit-frame-pointer', '-ffast-math', '-fstrength-reduce' ],
        # Flag to ensure that compiler error output includes column/line numbers
        'show-column' : '-fshow-column',
        # Flags required to build for x86 only (OS X feature)
        'generic-x86' : '',
        # Flags required to build for PowerPC only (OS X feature)
        'generic-ppc' : '',
        # Flags required to build for PowerPC only (OS X feature)
        'generic-arm64' : '',
        # All flags required to get basic warnings to be generated by the compiler
        'basic-warnings' : [ '-Wall', '-Wpointer-arith', '-Wcast-qual', '-Wcast-align', '-Wno-unused-parameter' ],
        # Any additional flags for warnings that are specific to C (not C++)
        'extra-c-warnings' : [ '-Wstrict-prototypes', '-Wmissing-prototypes' ],
        # Any additional flags for warnings that are specific to C++ (not C)
        'extra-cxx-warnings' : [ '-Woverloaded-virtual', '-Wno-unused-local-typedefs', '-Wno-deprecated-copy' ],
        # Flags used for "strict" compilation, C and C++ (i.e. compiler will warn about language issues)
        'strict' : ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings', '-Wunsafe-loop-optimizations', '-Wlogical-op' ],
        # Flags used for "strict" compilation, C only (i.e. compiler will warn about language issues)
        'c-strict' : ['-std=c99', '-pedantic', '-Wshadow'],
        # Flags used for "strict" compilation, C++ only (i.e. compiler will warn about language issues)
        'cxx-strict' : [ '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ],
        # Flags required for whatever consider the strictest possible compilation
        'ultra-strict' : ['-Wredundant-decls', '-Wstrict-prototypes', '-Wmissing-prototypes'],
        # Flag to turn on C99 compliance by itself
        'c99': '-std=c99',
        # Flag to enable AT&T assembler syntax
        'attasm': '-masm=att',
        # Flags to make AVX instructions/intrinsics available
        'avx': '-mavx',
        # Flags to make AVX512F instructions/intrinsics available
        'avx512f': '-mavx512f',
        # Flags to make FMA instructions/intrinsics available
        'fma': '-mfma',
        # Flags to make ARM/NEON instructions/intrinsics available
        'neon': '-mfpu=neon',
        # Flags to generate position independent code, when needed to build a shared object
        'pic': '-fPIC',
        # Flags required to compile C code with anonymous unions (only part of C11)
        'c-anonymous-union': '-fms-extensions',
    },
    'msvc' : {
        'debuggable' : ['/DDEBUG', '/Od', '/Zi', '/MDd', '/Gd', '/EHsc'],
        'linker-debuggable' : ['/DEBUG', '/INCREMENTAL' ],
        'nondebuggable' : ['/DNDEBUG', '/Ob1', '/MD', '/Gd', '/EHsc'],
        'profile' : '/Oy-',
        'silence-unused-arguments' : '',
        'sse' : '',
        'xsaveintrin' : '',
        'fpmath-sse' : '',
        'xmmintrinsics' : '',
        'pipe' : '',
        'full-optimization' : '/O2',
        'no-frame-pointer' : '',
        'fast-math' : '',
        'strength-reduce' : '',
        'show-column' : '',
        'generic-x86' : '',
        'generic-ppc' : '',
        'generic-arm64' : '',
        'basic-warnings' : '',
        'extra-c-warnings' : '',
        'extra-cxx-warnings' : '',
        'ultra-strict' : '',
        'c-strict' : '',
        'cxx-strict' : '',
        'strict' : '',
        'c99': '/TP',
        'attasm': '',
        'avx': '',
        'neon': '',
        'pic': '',
        'c-anonymous-union': '',
    },
}

# Copy, edit and insert variants on gcc dict for gcc-darwin and clang

gcc_darwin_dict = compiler_flags_dictionaries['gcc'].copy()
gcc_darwin_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual' ]
gcc_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual' ]
gcc_darwin_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
gcc_darwin_dict['generic-x86'] = [ '-arch', 'i386' ]
gcc_darwin_dict['generic-ppc'] = [ '-arch', 'ppc' ]
gcc_darwin_dict['generic-arm64'] = [ '-arch', 'arm64' ]
compiler_flags_dictionaries['gcc-darwin'] = gcc_darwin_dict

clang_dict = compiler_flags_dictionaries['gcc'].copy()
clang_dict['sse'] = ''
clang_dict['fpmath-sse'] = ''
clang_dict['xsaveintrin'] = ''
clang_dict['xmmintrinsics'] = ''
clang_dict['silence-unused-arguments'] = '-Qunused-arguments'
clang_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual', '-Wno-mismatched-tags', '-Wno-cast-align', '-Wno-unused-local-typedefs', '-Wunneeded-internal-declaration' ]
clang_dict['basic-warnings'] = [ '-Wall', '-Wpointer-arith', '-Wcast-qual', '-Wcast-align', '-Wno-unused-parameter', '-Wno-deprecated-declarations' ]
clang_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ]
clang_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
clang_dict['generic-x86'] = [ '-arch', 'i386' ]
clang_dict['generic-arm64'] = [ '-arch', 'arm64' ]
clang_dict['full-optimization'] = [ '-O3', '-fomit-frame-pointer', '-ffast-math', ]
compiler_flags_dictionaries['clang'] = clang_dict

clang_darwin_dict = compiler_flags_dictionaries['clang'].copy()
clang_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', ]
clang_darwin_dict['full-optimization'] = [ '-O3', '-ffast-math']
compiler_flags_dictionaries['clang-darwin'] = clang_darwin_dict

# Xcode 15 does not like our boost version, producing warnings from almost every file
clang15_darwin_dict = compiler_flags_dictionaries['clang-darwin'].copy()
clang15_darwin_dict['basic-warnings'] = clang15_darwin_dict['basic-warnings'] + ["-Wno-deprecated-builtins", "-Wno-deprecated-copy-with-user-provided-copy"]
compiler_flags_dictionaries['clang15-darwin'] = clang15_darwin_dict

# Version stuff

def fetch_git_revision_date ():
    cmd = ["git", "describe", "HEAD"]
    output = subprocess.Popen(cmd, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = re.sub(r"^[A-Za-z0-9]*\+", "", output[0].decode('utf-8'))

    cmd = ["git", "log", "-1", "--pretty=format:%ci", "HEAD"]
    output = subprocess.Popen(cmd, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    date = output[0].decode('utf-8').split(None, 2)[0]

    return rev, date

def fetch_tarball_revision_date():
    if not os.path.exists ('libs/ardour/revision.cc'):
        print ('This tarball was not created correctly - it is missing libs/ardour/revision.cc')
        sys.exit (1)
    with open('libs/ardour/revision.cc', 'rb') as f:
        content = f.readlines()
        remove_punctuation_map = dict((ord(char), None) for char in '";')

        raw_line_tokens = content[1].decode('utf-8').strip().split(' ')
        rev = raw_line_tokens[7].translate(remove_punctuation_map)
        date = raw_line_tokens[12].translate(remove_punctuation_map)

        return rev, date

def parse_macos_version(version):
    # The [.] matches to the dot after the major version, "." would match any character
    if re.search ("^[0-7][.]", version) is not None:
        return 'panther'
    elif re.search ("^8[.]", version) is not None:
        return 'tiger'
    elif re.search ("^9[.]", version) is not None:
        return 'leopard'
    elif re.search ("^10[.]", version) is not None:
        return 'snowleopard'
    elif re.search ("^11[.]", version) is not None:
        return 'lion'
    elif re.search ("^12[.]", version) is not None:
        return 'mountainlion'
    elif re.search ("^13[.]", version) is not None:
        return 'mavericks'
    elif re.search ("^14[.]", version) is not None:
        return 'yosemite'
    elif re.search ("^15[.]", version) is not None:
        return 'el_capitan'
    elif re.search ("^16[.]", version) is not None:
        return 'sierra'
    elif re.search ("^17[.]", version) is not None:
        return 'high_sierra'
    elif re.search ("^18[.]", version) is not None:
        return 'mojave'
    elif re.search ("^19[.]", version) is not None:
        return 'catalina'
    elif re.search ("^20[.]", version) is not None:
        return 'bigsur'
    elif re.search ("^21[.]", version) is not None:
        return 'monterey'
    elif re.search ("^22[.]", version) is not None:
        return 'ventura'
    elif re.search ("^23[.]", version) is not None:
        return 'sonoma'
    elif re.search ("^24[.]", version) is not None:
        return 'sequoia'
    else:
        return 'sequoia'


def set_version (from_file = False):
    def sanitize(s):
        # round-trip to remove anything in the string that is not encodable in
        # ASCII, yet still keep a real (utf8-encoded internally) string.
        s = s.encode ('ascii', 'ignore').decode ("utf-8")
        # In Python3, bytes is the class of binary content and encode() returns
        # bytes to transform a string according to a text encoding; str is the
        # class of normal strings (utf8-encoded internally) and decode() returns
        # that type.
        # Python 2 did not initially cater for encoding problems and can use str
        # for both binary content and for (decoded) strings. The Unicode type was
        # added to correspond to Python 3 str, and the Python 2 str type should
        # only correspond to bytes. Alas, almost everything in the Python 2
        # ecosystem has been written with str in mind and doesn't handle Unicode
        # objects correctly. If Python 2 is in use, s will be a Unicode object and
        # to avoid strange problems later we convert back to str, but in utf-8
        # nonetheless.
        if not isinstance(s, str):
            s = s.encode("utf-8")
        return s

    global MAJOR
    global MINOR
    global MICRO
    global VERSION
    global PROGRAM_VERSION
    global rev_date

    if not from_file and os.path.isdir (os.path.join(os.getcwd(), '.git')):
        rev, rev_date = fetch_git_revision_date()
    else:
        rev, rev_date = fetch_tarball_revision_date()

=== gtk2_ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import sys
import re
import subprocess
import glob

@TaskGen.extension('.m')
def m_hook(self, node):
    """Alias .m files to be compiled the same as .c files, gcc will do the right thing."""
    return self.create_compiled_task('c', node)

gtk2_ardour_sources = [
        'about.cc',
        'actions.cc',
        'add_route_dialog.cc',
        'ambiguous_file_dialog.cc',
        'analysis_window.cc',
        'ardour_dialog.cc',
        'ardour_http.cc',
        'ardour_message.cc',
        'ardour_ui.cc',
        'ardour_ui2.cc',
        'ardour_ui3.cc',
        'ardour_ui_aaf.cc',
        'ardour_ui_access_web.cc',
        'ardour_ui_dependents.cc',
        'ardour_ui_dialogs.cc',
        'ardour_ui_ed.cc',
        'ardour_ui_engine.cc',
        'ardour_ui_keys.cc',
        'ardour_ui_mixer.cc',
        'ardour_ui_options.cc',
        'ardour_ui_session.cc',
        'ardour_ui_startup.cc',
        'ardour_ui_video.cc',
        'ardour_window.cc',
        'audio_clock.cc',
        'audio_clip_editor.cc',
        'audio_region_editor.cc',
        'audio_region_view.cc',
        'audio_region_operations_box.cc',
        'audio_region_properties_box.cc',
        'audio_trigger_properties_box.cc',
        'audio_streamview.cc',
        'audio_time_axis.cc',
        'automation_controller.cc',
        'automation_line.cc',
        'automation_region_view.cc',
        'automation_streamview.cc',
        'automation_time_axis.cc',
        'axis_view.cc',
        # 'beatbox_gui.cc',
        'bbt_marker_dialog.cc',
        'big_clock_window.cc',
        'big_transport_window.cc',
        'bundle_manager.cc',
        'clock_group.cc',
        'color_theme_manager.cc',
        'configinfo.cc',
        'control_point.cc',
        'control_point_dialog.cc',
        'control_slave_ui.cc',
        'cuebox_ui.cc',
        'cursor_context.cc',
        'curvetest.cc',
        'debug.cc',
        'dsp_stats_ui.cc',
        'dsp_stats_window.cc',
        'duplicate_routes_dialog.cc',
        'edit_note_dialog.cc',
        'editing.cc',
        'editor.cc',
        'editor_actions.cc',
        'editor_audio_import.cc',
        'editor_pt_import.cc',
        'editor_audiotrack.cc',
        'editor_canvas.cc',
        'editor_canvas_events.cc',
        'editor_component.cc',
        'editor_cursors.cc',
        'editor_drag.cc',
        'editor_route_groups.cc',
        'editor_section_box.cc',
        'editor_export_audio.cc',
        'editor_group_tabs.cc',
        'editor_keys.cc',
        'editor_locations.cc',
        'editor_markers.cc',
        'editor_mixer.cc',
        'editor_mouse.cc',
        'editor_ops.cc',
        'editor_regions.cc',
        'editor_routes.cc',
        'editor_rulers.cc',
        'editor_sections.cc',
        'editor_selection.cc',
        'editor_snapshots.cc',
        'editor_sources.cc',
        'editor_summary.cc',
        'editor_tempodisplay.cc',
        'editor_timefx.cc',
        'engine_dialog.cc',
        'enums.cc',
        'export_analysis_graphs.cc',
        'export_channel_selector.cc',
        'export_dialog.cc',
        'export_file_notebook.cc',
        'export_filename_selector.cc',
        'export_format_dialog.cc',
        'export_format_selector.cc',
        'export_preset_selector.cc',
        'export_report.cc',
        'export_timespan_selector.cc',
        'fitted_canvas_widget.cc',
        'fft.cc',
        'fft_graph.cc',
        'fft_result.cc',
        'floating_text_entry.cc',
        'foldback_strip.cc',
        'sfdb_freesound_mootcher.cc',
        'gain_meter.cc',
        'generic_pluginui.cc',
        'ghostregion.cc',
        'global_port_matrix.cc',
        'group_tabs.cc',
        'gui_object.cc',
        'idleometer.cc',
        'input_port_monitor.cc',
        'insert_remove_time_dialog.cc',
        'instrument_selector.cc',
        'interthread_progress_window.cc',
        'io_button.cc',
        'io_plugin_window.cc',
        'io_selector.cc',
        'hit.cc',
        'keyboard.cc',
        'keyeditor.cc',
        'led.cc',
        'level_meter.cc',
        'library_download_dialog.cc',
        'location_ui.cc',
        'loudness_dialog.cc',
        'loudness_settings.cc',
        'lua_script_manager.cc',
        'luadialog.cc',
        'luainstance.cc',
        'luawindow.cc',
        'main.cc',
        'main_clock.cc',
        'marker.cc',
    	'mergeable_line.cc',
        'midi_automation_line.cc',
        'midi_channel_dialog.cc',
        'midi_channel_selector.cc',
        'midi_clip_editor.cc',
        'midi_cut_buffer.cc',
        'midi_export_dialog.cc',
        'midi_list_editor.cc',
        'midi_region_view.cc',
        'midi_region_operations_box.cc',
        'midi_region_properties_box.cc',
        'midi_trigger_properties_box.cc',
        'midi_selection.cc',
        'midi_streamview.cc',
        'midi_time_axis.cc',
        'midi_tracer.cc',
        'midi_velocity_dialog.cc',
        'mini_timeline.cc',
        'missing_file_dialog.cc',
        'missing_filesource_dialog.cc',
        'missing_plugin_dialog.cc',
        'mixer_group_tabs.cc',
        'mixer_strip.cc',
        'mixer_ui.cc',
        'meterbridge.cc',
        'meter_strip.cc',
        'meter_patterns.cc',
        'monitor_section.cc',
        'mono_panner.cc',
        'mono_panner_editor.cc',
        'mouse_cursors.cc',
        'multi_region_properties_box.cc',
        'nag.cc',
        'new_plugin_preset_dialog.cc',
        'new_user_wizard.cc',
        'normalize_dialog.cc',
        'note.cc',
        'note_base.cc',
        'note_player.cc',
        'note_select_dialog.cc',
        'nsm.cc',
        'nsmclient.cc',
        'option_editor.cc',
        'opts.cc',
        'panner2d.cc',
        'panner_editor.cc',
        'panner_interface.cc',
        'panner_ui.cc',
        'patch_change.cc',
        'patch_change_widget.cc',
        'pianokeyboard.cc',
        'piano_key_bindings.cc',
        'piano_roll_header.cc',
        'pingback.cc',
        'playlist_selector.cc',
        'plugin_display.cc',
        'plugin_eq_gui.cc',
        'plugin_manager_ui.cc',
        'plugin_pin_dialog.cc',
        'plugin_presets_ui.cc',
        'plugin_scan_dialog.cc',
        'plugin_setup_dialog.cc',
        'plugin_selector.cc',
        'plugin_ui.cc',
        'plugin_dspload_ui.cc',
        'plugin_dspload_window.cc',
        'plugin_window_proxy.cc',
        'port_group.cc',
        'port_insert_ui.cc',
        'port_matrix.cc',
        'port_matrix_body.cc',
        'port_matrix_column_labels.cc',
        'port_matrix_component.cc',
        'port_matrix_grid.cc',
        'port_matrix_labels.cc',
        'port_matrix_row_labels.cc',
        'processor_box.cc',
        'processor_selection.cc',
        'patch_change_dialog.cc',
        'progress_reporter.cc',
        'pt_import_selector.cc',
        'public_editor.cc',
        'quantize_dialog.cc',
        'rc_option_editor.cc',
        'rec_info_box.cc',
        'recorder_group_tabs.cc',
        'recorder_ui.cc',
        'region_editor.cc',
        'region_fx_line.cc',
        'region_gain_line.cc',
        'region_layering_order_editor.cc',
        'region_list_base.cc',
        'region_peak_cursor.cc',
        'region_selection.cc',
        'region_view.cc',
        'return_ui.cc',
        'rhythm_ferret.cc',
        'route_group_dialog.cc',
        'route_group_menu.cc',
        'route_list_base.cc',
        'route_params_ui.cc',
        'route_processor_selection.cc',
        'route_time_axis.cc',
        'route_ui.cc',
        'ruler_dialog.cc',
        'save_as_dialog.cc',
        'save_template_dialog.cc',
        'search_path_option.cc',
        'screensaver.cc',
        'script_selector.cc',
        'selection.cc',
        'selection_properties_box.cc',
        'selection_memento.cc',
        'send_ui.cc',
        'session_archive_dialog.cc',
        'session_dialog.cc',
        'session_import_dialog.cc',
        'session_metadata_dialog.cc',
        'session_option_editor.cc',
        'sfdb_ui.cc',
        'shuttle_control.cc',
        'simple_export_dialog.cc',
        'slot_properties_box.cc',
        'source_list_base.cc',
        'soundcloud_export_selector.cc',
        'splash.cc',
        'speaker_dialog.cc',
        'startup_fsm.cc',
        'step_editor.cc',
        'step_entry.cc',
        'stereo_panner.cc',
        'stereo_panner_editor.cc',
        'streamview.cc',
        'strip_silence_dialog.cc',
        'stripable_colorpicker.cc',
        'stripable_time_axis.cc',
        'surround_strip.cc',
        'sys_ex.cc',
        'template_dialog.cc',
        'tempo_curve.cc',
        'tempo_dialog.cc',
        'grid_lines.cc',
        'tempo_map_change.cc',
        'time_axis_view.cc',
        'time_axis_view_item.cc',
        'time_fx_dialog.cc',
        'time_info_box.cc',
        'time_selection.cc',
        'timectl_gui.cc',
        'timers.cc',
        'track_record_axis.cc',
        'track_selection.cc',
        'track_view_list.cc',
        'transform_dialog.cc',
        'transport_control.cc',
        'transport_control_ui.cc',
        'transport_masters_dialog.cc',
        'transpose_dialog.cc',
        'trigger_clip_picker.cc',
        'trigger_jump_dialog.cc',
        'trigger_page.cc',
        'trigger_region_list.cc',
        'trigger_route_list.cc',
        'trigger_source_list.cc',
        'trigger_strip.cc',
        'trigger_master.cc',
        'trigger_ui.cc',
        'triggerbox_ui.cc',
        'ui_config.cc',
        'utils.cc',
        'varispeed_dialog.cc',
        'vca_master_strip.cc',
        'verbose_cursor.cc',
        'virtual_keyboard_window.cc',
        'visibility_group.cc',
        'window_manager.cc',
        # video-timeline related sources:
        'video_image_frame.cc',
        'add_video_dialog.cc',
        'editor_videotimeline.cc',
        'vca_time_axis.cc',
        'video_timeline.cc',
        'video_monitor.cc',
        'transcode_ffmpeg.cc',
        'transcode_video_dialog.cc',
        'velocity_ghost_region.cc',
        'video_server_dialog.cc',
        'utils_videotl.cc',
        'export_video_dialog.cc'
]

def enoify (major, minor):
    # Code names based on
    # https://en.wikipedia.org/wiki/Brian_Eno_discography
    #
    # sort Studio albums + Collaborative albums + Compilation albums by Month/Year.
    # (no Singles, no EPs, no Video Albums, no Production)
    if major == 3:
        return "\\n\\\"E-No\\\""
    elif major == 4:
        if minor == 0:
            return "\\n\\\"No Pussyfooting\\\""
        elif minor == 1:
            return "\\n\\\"Here Come the Warm Jets\\\""
        elif minor == 2:
            return "\\n\\\"Taking Tiger Mountain\\\""
        elif minor == 3:
            return "\\n\\\"Lady June's Linguistic Leprosy\\\""
        elif minor == 4:
            return "\\n\\\"Discreet Music\\\""
        elif minor == 5:
            return "\\n\\\"Another Green World\\\""
        elif minor == 6:
            return "\\n\\\"Evening Star\\\""
        elif minor == 7:
            return "\\n\\\"Cluster and Eno\\\""
    elif major == 5:
        if minor == 0:
            return "\\n\\\"Before and After Science\\\""
        elif minor == 1:
            return "\\n\\\"After the Heat\\\""
        elif minor == 2:
            return "\\n\\\"Music for Airports\\\""
        elif minor == 3:
            return "\\n\\\"Music for Films\\\""
        elif minor == 4:
            return "\\n\\\"In a Land of Clear Colours\\\""
        elif minor == 5:
            return "\\n\\\"The Plateaux of Mirror\\\""
        elif minor == 6:
            return "\\n\\\"Possible Musics\\\"" # 1980 Collaborative
        elif minor == 7:
            return "\\n\\\"My Life in the Bush of Ghosts\\\"" # 1981
        elif minor == 8:

=== headless/wscript ===
#!/usr/bin/env python
import os
import sys

hardour_sources = [
        'load_session.cc',
        'misc.cc',
]

def options(opt):
    pass

def configure(conf):
    pass

def build(bld):
    # just the normal executable version of the GTK GUI
    obj = bld (features = 'cxx c cxxprogram')
    # this program does not do the whole hidden symbols thing
    obj.cxxflags = [ '-fvisibility=default' ]
    obj.source    = hardour_sources
    obj.target = 'hardour-' + bld.env['VERSION']
    obj.includes = ['.']
    obj.use      = [ 'libpbd',
                     'libardour',
                     'libardour_cp',
                     'libtemporal',
                     'libmidipp',
                     ]

    obj.defines = [
        'VERSIONSTRING="' + bld.env['VERSION'] + '"',
        'DATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
        'LOCALEDIR="' + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
        ]
    obj.install_path = bld.env['LIBDIR']
    obj.uselib       = 'UUID FLAC FONTCONFIG GLIBMM GIOMM GTHREAD OGG CURL DL XML'
    obj.uselib       += ' AUDIOUNITS OSX'
    obj.uselib       += ' FFTW3F LO TAGLIB LILV RUBBERBAND AUBIO LRDF ARCHIVE VAMPSDK VAMPHOSTSDK'

    if bld.is_defined('HAVE_SUIL'):
        if bld.is_defined('YTK'):
            obj.use += [ 'libsuil' ]
        else:
            obj.uselib += ' SUIL'

    if bld.is_defined('HAVE_USB'):
        obj.uselib += ' USB'

    if sys.platform == 'darwin':
        obj.uselib += ' AUDIOUNITS OSX'
        obj.use    += ' libappleutility'
    obj.includes += ['../libs']

    if bld.env['build_target'] == 'mingw':
        if bld.env['DEBUG'] == False:
            obj.linkflags = ['-mwindows']

    if bld.is_defined('NEED_INTL'):
        obj.linkflags = ' -lintl'

=== session_utils/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import waflib.Utils as Utils
import os
import sys

def options(opt):
    pass

def configure(conf):
    if not "dummy" in conf.env['BACKENDS']:
        print ('session-utils depend on the dummy backend.')
        autowaf.display_msg(conf, 'build session-utils', 'no')
        return

    autowaf.display_msg(conf, 'build session-utils', 'yes')

def build_ardour_util(bld, util):
    pgmprefix = bld.env['PROGRAM_NAME'].lower() + bld.env['MAJOR']

    # just the normal executable version of the GTK GUI
    obj = bld (features = 'cxx c cxxprogram')
    # this program does not do the whole hidden symbols thing
    obj.cxxflags = [ '-fvisibility=default' ]
    obj.source   = ['common.cc', util + '.cc' ]
    obj.target   = pgmprefix + '-' + util
    obj.includes = ['.']
    obj.use      = [ 'libpbd',
                     'libardour',
                     'libardour_cp',
                     'libtemporal',
                     'libmidipp',
                     ]
    obj.defines = [
        'VERSIONSTRING="' + bld.env['VERSION'] + '"',
        'UTILNAME="'   + str(pgmprefix + '-' + util) + '"',
        'DATA_DIR="'   + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
        'LOCALEDIR="'  + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
        'PACKAGE="'    + "ARDOURUTILS" + '"',
        ]
    obj.install_path = bld.env['LIBDIR'] + '/utils'
    obj.uselib       = 'UUID FLAC FONTCONFIG GLIBMM GIOMM GTHREAD OGG CURL DL XML'
    obj.uselib       += ' AUDIOUNITS OSX LO '
    obj.uselib       += ' FFTW3F LO TAGLIB LILV RUBBERBAND AUBIO LRDF ARCHIVE VAMPSDK VAMPHOSTSDK'

    if bld.is_defined('HAVE_SUIL'):
        if bld.is_defined('YTK'):
            obj.use += [ 'libsuil' ]
        else:
            obj.uselib += ' SUIL'

    if bld.is_defined('HAVE_USB'):
        obj.uselib += ' USB'

    if sys.platform == 'darwin':
        obj.uselib += ' AUDIOUNITS OSX'
        obj.use    += ' libappleutility'
    obj.includes += ['../libs']

    if bld.env['build_target'] == 'mingw':
        obj.install_path = bld.env['BINDIR']

    if bld.is_defined('NEED_INTL'):
        obj.linkflags = ' -lintl'

def build(bld):
    # session-utils depend on the dummy backend
    if not "dummy" in bld.env['BACKENDS']:
        return

    pgmprefix = bld.env['PROGRAM_NAME'].lower() + bld.env['MAJOR']

    utils = bld.path.ant_glob('[a-z]*.cc', excl=['example.cc', 'common.cc'])

    for util in utils:
        fn = os.path.splitext(os.path.basename(str(util)))[0]
        build_ardour_util(bld, fn)
        if bld.env['build_target'] != 'mingw':
            bld.symlink_as(bld.env['BINDIR'] + '/' + pgmprefix + "-" + fn, bld.env['LIBDIR'] + '/utils/ardour-util.sh')

    if bld.env['build_target'] == 'mingw':
        return

    obj              = bld(features = 'subst')
    obj.source       = 'ardour-util.sh.in'
    obj.target       = 'ardour-util.sh'
    obj.chmod        = Utils.O755
    obj.install_path = bld.env['LIBDIR']  + '/utils'
    obj.LIBDIR       = os.path.normpath(bld.env['DLLDIR'])
    obj.DATADIR      = os.path.normpath(bld.env['DATADIR'])
    obj.CONFDIR      = os.path.normpath(bld.env['CONFDIR'])

=== libs/aaf/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
LIBAAF_VERSION = '0.0.0'
LIBAAF_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'libaaf'
VERSION = LIBAAF_VERSION
I18N_PACKAGE = 'libaaf'

# Mandatory variables
top = '.'
out = 'build'

libaaf_sources = [
	'AAFClass.c',
	'AAFCore.c',
	'AAFDump.c',
	'AAFIEssenceFile.c',
	'AAFIface.c',
	'AAFIParser.c',
	'AAFToText.c',
	'CFBDump.c',
	'LibCFB.c',
	'ProTools.c',
	'MediaComposer.c',
	'Resolve.c',
	'RIFFParser.c',
	'URIParser.c',
	'utils.c',
	'log.c',
]

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    if False and conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'libaaf', uselib_store='LIBAAF', mandatory=True, atleast_version='0.6.0')

def build(bld):
    if False and bld.is_defined('USE_EXTERNAL_LIBS'):
        return

    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cshlib', source=libaaf_sources)
        obj.defines = [ 'LIBAAF_DLL_EXPORTS=1' ]
    else:
        obj              = bld.stlib(features = 'c cshlib', source=libaaf_sources)
        obj.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines      = []

    obj.export_includes  = ['.']
    obj.includes         = ['.']
    obj.name             = 'libaaf'
    obj.target           = 'aaf'
    #obj.uselib          = 'GLIB'
    obj.vnum             = LIBAAF_LIB_VERSION
    obj.install_path     = bld.env['LIBDIR']
    obj.defines         += [ 'PACKAGE="' + I18N_PACKAGE + '"', '_POSIX_C_SOURCE=200809L', '_XOPEN_SOURCE=500' ]

def shutdown():
    autowaf.shutdown()

=== libs/ardouralsautil/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import sys
import re

def options(opt):
    pass

def configure(conf):
    if re.search ("linux", sys.platform) != None and Options.options.dist_target != 'mingw':
        autowaf.check_pkg(conf, 'alsa', uselib_store='ALSA')
        autowaf.check_pkg(conf, 'dbus-1', uselib_store='DBUS', mandatory = False)

def build(bld):
    if re.search ("linux", sys.platform) != None:
        if bld.is_defined('HAVE_ALSA'):
            obj = bld(features = 'cxx cxxshlib')
            obj.source = [
                'devicelist.cc',
                'deviceparams.cc'
            ]
            obj.export_includes = ['.']
            obj.includes = ['.']
            obj.name     = 'ardouralsautil'
            obj.target   = 'ardouralsautil'
            obj.use      = 'libpbd'
            obj.uselib   = [ 'ALSA', 'GLIBMM' ]
            obj.vnum     = '0.0.1'
            obj.install_path = os.path.join(bld.env['LIBDIR'])

        if bld.env['BUILD_ALSABACKEND'] and bld.is_defined('HAVE_ALSA') and bld.is_defined('HAVE_DBUS'):
            obj = bld(features = 'c cprogram')
            obj.source = [
                'reserve.c',
                'request_device.c'
            ]
            obj.includes = ['.']
            obj.cflags   = [ '-pthread' ]
            obj.target   = 'ardour-request-device'
            obj.uselib   = [ 'DBUS' ]
            obj.install_path = os.path.join(bld.env['LIBDIR'])
            obj.defines = [
                    '_POSIX_SOURCE',
                    '_XOPEN_SOURCE=500',
                    'ARD_PROG_NAME="ardour-request-device"',
                    'ARD_APPL_NAME="Ardour ALSA Backend"',
            ]

=== libs/auscan/wscript ===
#!/usr/bin/env python
import os

# needed for code used from libardour
I18N_PACKAGE = 'ardour'

def options(opt):
    pass

def configure(conf):
    pass

def build(bld):
    if bld.is_defined('AUDIOUNIT_SUPPORT'):
        obj = bld (features = 'cxx c cxxprogram')
        obj.source    = 'au-scanner.cc'
        obj.target    = 'ardour-au-scanner'
        obj.includes  = [ '../pbd/', '../ardour/', '..' ]
        obj.defines   = [
            'AU_SCANNER_APP',
            'VERSIONSTRING="' + bld.env['VERSION'] + '"',
            'PACKAGE="' + I18N_PACKAGE + bld.env['MAJOR'] + '"',
            'LIBARDOUR="' + bld.env['lwrcase_dirname'] + '"',
            'LOCALEDIR="' + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
            ]
        obj.use = [ 'libpbd', 'libappleutility', 'libtemporal', 'libevoral' ]
        obj.uselib = 'GIOMM DL UUID ARCHIVE CURL XML COREAUDIO AUDIOUNITS OSX'
        obj.install_path = os.path.join(bld.env['LIBDIR'])
        obj.cxxflags = ['-Wno-deprecated-declarations']

=== libs/canvas/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
MAJOR = '0'
MINOR = '0'
MICRO = '0'
CANVAS_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
CANVAS_LIB_VERSION = '0.0.0'

I18N_PACKAGE = 'libcanvas'

canvas_sources = [
        'arc.cc',
        'arrow.cc',
        'box.cc',
        'canvas.cc',
        'circle.cc',
        'container.cc',
        'curve.cc',
        'debug.cc',
        'item.cc',
        'fill.cc',
        'flag.cc',
        'framed_curve.cc',
        'grid.cc',
        'image.cc',
        'line.cc',
        'line_set.cc',
        'lollipop.cc',
        'lookup_table.cc',
        'meter.cc',
        'note.cc',
        'outline.cc',
        'pixbuf.cc',
        'poly_item.cc',
        'poly_line.cc',
        'polygon.cc',
        'rectangle.cc',
        'root_group.cc',
        'ruler.cc',
        'scroll_group.cc',
        'stateful_image.cc',
        'step_button.cc',
        'table.cc',
        'text.cc',
        'tracking_text.cc',
        'types.cc',
        'utils.cc',
        'widget.cc',
        'xfade_curve.cc',
]

def options(opt):
    pass

def configure(conf):
    autowaf.check_pkg(conf, 'cairomm-1.0', uselib_store='CAIROMM', atleast_version='1.8.4')

def build(bld):
    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj = bld.shlib(features = 'cxx cxxshlib', source=canvas_sources)
        obj.defines      = [ 'LIBCANVAS_DLL_EXPORTS=1' ]
    else:
        obj = bld.stlib(features = 'cxx cxxstlib', source=canvas_sources)
        obj.cxxflags = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.cflags   = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines  = [ ]

    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.uselib       = 'SIGCPP CAIROMM PANGOMM BOOST XML OSX'
    obj.use          = [ 'libpbd', 'libgtkmm2ext' ]
    obj.name         = 'libcanvas'
    obj.target       = 'canvas'
    obj.vnum         = CANVAS_LIB_VERSION
    obj.install_path = bld.env['LIBDIR']
    obj.defines      += [ 'PACKAGE="' + I18N_PACKAGE + '"' ]

    if bld.is_defined('YTK'):
        obj.use    += [ 'libytkmm' ]
        obj.uselib += ' GLIBMM GIOMM'
    else:
        obj.uselib += ' GTKMM'

    # canvas unit-tests are outdated
    if False and bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
            unit_testobj              = bld(features = 'cxx cxxprogram')
            unit_testobj.source       = '''
                    test/group.cc
                    test/arrow.cc
                    test/optimizing_lookup_table.cc
                    test/polygon.cc
                    test/types.cc
                    test/render.cc
                    test/xml.cc
                    test/wave_view.cc
                    test/item.cc
                    test/testrunner.cpp
                '''.split()

            unit_testobj.includes     = obj.includes + ['test', '../pbd']
            unit_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
            unit_testobj.uselib_local = 'libcanvas libgtkmm2ext'
            unit_testobj.name         = 'libcanvas-unit-tests'
            unit_testobj.target       = 'run-tests'
            unit_testobj.install_path = ''
            unit_testobj.cxxflags     = ['-DPACKAGE="libcanvastest"']
            unit_testobj.cxxflags     += ['-DDATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"']
            unit_testobj.cxxflags     += ['-DCONFIG_DIR="' + os.path.normpath(bld.env['CONFDIR']) + '"']
            unit_testobj.cxxflags     += ['-DMODULE_DIR="' + os.path.normpath(bld.env['LIBDIR']) + '"']

            manual_tests              = '''
                        test/hello_world.cc
                        test/gtk_many.cc
                        test/gtk_scene.cc
                        test/gtk_movement.cc
                        test/gtk_viewport.cc
                        test/gtk_drag.cc
                '''.split()

            for t in manual_tests:
                    target = t[:-3]
                    name = t[t.find('/')+1:-3]
                    manual_testobj = bld(features = 'cxx cxxprogram')
                    manual_testobj.source = t
                    manual_testobj.includes = obj.includes + ['test', '../pbd']
                    manual_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
                    manual_testobj.uselib_local = 'libcanvas libgtkmm2ext'
                    manual_testobj.name         = 'libcanvas-manual-test-%s' % name
                    manual_testobj.target       = target
                    manual_testobj.install_path = ''

            benchmarks = '''
                        benchmark/items_at_point.cc
                        benchmark/render_parts.cc
                        benchmark/render_from_log.cc
                        benchmark/render_whole.cc
                '''.split()

            for t in benchmarks:
                    target = t[:-3]
                    name = t[t.find('/')+1:-3]
                    manual_testobj = bld(features = 'cxx cxxprogram')
                    manual_testobj.source = [ t, 'benchmark/benchmark.cc' ]
                    manual_testobj.includes = obj.includes + ['test', '../pbd']
                    manual_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
                    manual_testobj.uselib_local = 'libcanvas libgtkmm2ext'
                    manual_testobj.name         = 'libcanvas-benchmark-%s' % name
                    manual_testobj.target       = target
                    manual_testobj.install_path = ''

=== libs/evoral/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os

# Version of this package (even if built as a child)
EVORAL_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
EVORAL_LIB_VERSION = '0.0.0'

def options(opt):
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                    help="Build unit tests")
    opt.add_option('--test-coverage', action='store_true', default=False, dest='test_coverage',
                    help="Use gcov to test for code coverage")
    opt.add_option('--internal-shared-libs', action='store_true', default=True, dest='internal_shared_libs',
                   help='Build internal libs as shared libraries')

def configure(conf):
    #autowaf.display_header('Evoral Configuration')

    if not autowaf.is_child():
        autowaf.check_pkg(conf, 'libpbd-4', uselib_store='LIBPBD', atleast_version='4.0.0', mandatory=True)

    # Boost headers

    conf.env['BUILD_TESTS'] = Options.options.build_tests
    conf.env['TEST_COVERAGE'] = Options.options.test_coverage

    if Options.options.internal_shared_libs:
        conf.define('INTERNAL_SHARED_LIBS', 1)
    #autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
    #print

def build(bld):
    # Headers
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.h')
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.h')

    # Pkgconfig file
    #autowaf.build_pc(bld, 'EVORAL', EVORAL_VERSION, 'GLIBMM GTHREAD')

    libsmf = bld(features = 'c cstlib')
    libsmf.source = '''
            libsmf/smf.c
            libsmf/smf_decode.c
            libsmf/smf_load.c
            libsmf/smf_save.c
            libsmf/smf_tempo.c
    '''
    libsmf.export_includes = ['.']
    libsmf.defines      = ['SMF_VERSION="1.2"', 'LIBSMF_DLL_EXPORTS']
    libsmf.includes     = ['./src']
    libsmf.name         = 'libsmf'
    libsmf.target       = 'smf'
    libsmf.uselib       = 'GLIB'
    libsmf.use          = [ 'libtemporal' ]
    libsmf.install_path = None
    if bld.env['build_target'] != 'mingw':
        libsmf.cxxflags     = [ bld.env['compiler_flags_dict']['pic'] ]
        libsmf.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]

    lib_source = '''
            Control.cc
            ControlList.cc
            ControlSet.cc
            Curve.cc
            Event.cc
            Note.cc
            SMF.cc
            Sequence.cc
            debug.cc
    '''

    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=lib_source)
        # DLL exports for this library
        obj.defines      = [ 'LIBEVORAL_DLL_EXPORTS' ]
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=lib_source)
        obj.cxxflags     = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines      = [ ]

    obj.export_includes = ['.']
    obj.includes       = ['.', './src']
    obj.name           = 'libevoral'
    obj.target         = 'evoral'
    obj.uselib         = 'GLIBMM GTHREAD SMF XML LIBPBD OSX'
    obj.use            = 'libsmf libpbd'
    obj.vnum           = EVORAL_LIB_VERSION
    obj.install_path   = bld.env['LIBDIR']
    obj.defines       += [ 'PACKAGE="libevoral"' ]

    # disable unit-tests -- build is broken with nutempo
    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Static library (for unit test code coverage)
        obj = bld(features = 'cxx cstlib')
        obj.source         = lib_source
        obj.export_includes = ['.']
        obj.includes       = ['.', './src']
        obj.name           = 'libevoral_static'
        obj.target         = 'evoral_static'
        obj.uselib         = 'GLIBMM GTHREAD SMF XML LIBPBD'
        obj.use            = 'libsmf libpbd'
        obj.vnum           = EVORAL_LIB_VERSION
        obj.install_path   = ''
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = ['--coverage']
            obj.cflags         = ['--coverage']
            obj.cxxflags       = ['--coverage']
        obj.defines        = ['PACKAGE="libevoral"']

        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = [
                'test/SequenceTest.cc',
                'test/SMFTest.cc',
                'test/NoteTest.cc',
                'test/CurveTest.cc',
                'test/testrunner.cc',
                ]
        obj.includes     = ['.', './src']
        obj.use          = 'libevoral_static'
        obj.uselib       = 'GLIBMM GTHREAD SMF XML LIBPBD OSX CPPUNIT'
        obj.target       = 'run-tests'
        obj.name         = 'libevoral-tests'
        obj.install_path = ''
        obj.defines      = ['PACKAGE="libevoraltest"']
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = ['--coverage']
            obj.cflags         = ['--coverage']
            obj.cxxflags       = ['--coverage']

def test(ctx):
    autowaf.pre_test(ctx, 'evoral')
    print(os.getcwd())
    os.environ['EVORAL_TEST_PATH'] = os.path.abspath('../test/testdata/')
    autowaf.run_tests(ctx, 'evoral', ['./run-tests'])
    autowaf.post_test(ctx, 'evoral')

=== libs/fluidsynth/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf

# Version of this package (even if built as a child)
MAJOR = '2'
MINOR = '0'
MICRO = '1'
LIBFLUIDSYNTH_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

I18N_PACKAGE = 'libfluidsynth'

def options(opt):
    pass

def configure(conf):
    if conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'fluidsynth', uselib_store='LIBFLUIDSYNTH', atleast_version=LIBFLUIDSYNTH_VERSION, mandatory=True)

def build(bld):
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        return
    bld (export_includes = ['fluidsynth'],
         name = 'libfluidsynth_includes'
         )
    obj = bld.stlib (source = [
        'src/fluid_midi.c',
        'src/fluid_adsr_env.c',
        'src/fluid_chorus.c',
        'src/fluid_iir_filter.c',
        'src/fluid_lfo.c',
        'src/fluid_rev.c',
        'src/fluid_rvoice.c',
        'src/fluid_rvoice_dsp.c',
        'src/fluid_rvoice_event.c',
        'src/fluid_rvoice_mixer.c',
        'src/fluid_defsfont.c',
        'src/fluid_chan.c',
        'src/fluid_event.c',
        'src/fluid_gen.c',
        'src/fluid_mod.c',
        'src/fluid_synth.c',
        'src/fluid_tuning.c',
        'src/fluid_voice.c',
        'src/fluid_conv.c',
        'src/fluid_hash.c',
        'src/fluid_list.c',
        'src/fluid_ringbuffer.c',
        'src/fluid_samplecache.c',
        'src/fluid_settings.c',
        'src/fluid_sffile.c',
        'src/fluid_sfont.c',
        'src/fluid_synth_monopoly.c',
        'src/fluid_sys.c'
        ],
        cflags = [ bld.env['compiler_flags_dict']['pic'], '-fvisibility=hidden', '-std=gnu99', '-Wno-unused-function' ],
        includes = ['.', 'src/' ],
               target = 'libfluidsynth',
               use    = 'libfluidsynth_includes',
               uselib = 'GLIB',
               defines = [ 'HAVE_CONFIG_H', 'DEFAULT_SOUNDFONT=""' ]
               )

=== libs/hidapi/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import re
import sys

HIDAPI_VERSION = '0.8.0'

def options(opt):
    pass

def configure(conf):
    if conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'hidapi-hidraw', uselib_store='HIDAPI', mandatory=False)
    else:
        if conf.env['build_target'] == 'mingw':
            conf.check (compiler='cxx', lib='setupapi', mandatory=True, uselib_store='SETUPAPI')
            conf.define ('HAVE_HIDAPI', 1)
        elif sys.platform == 'darwin':
            conf.define ('HAVE_HIDAPI', 1)
        elif re.search ("linux", sys.platform) != None:
            autowaf.check_pkg(conf, 'libudev', uselib_store='UDEV', mandatory=False)
            if conf.is_defined('HAVE_UDEV'):
                conf.define ('HAVE_HIDAPI', 1)
        else:
            print ("hidapi is not yet available for the given system")

def build(bld):
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        return
    if not bld.is_defined('HAVE_HIDAPI'):
        return

    # Host Library
    obj = bld(features = 'c cstlib')
    autowaf.ensure_visible_symbols (obj, False)
    obj.export_includes    = ['hidapi']
    obj.includes           = ['hidapi']
    obj.defines            = ['_POSIX_C_SOURCE=200809L']
    obj.name               = 'hidapi'
    obj.target             = 'hidapi'
    obj.vnum               = HIDAPI_VERSION
    obj.install_path       = bld.env['LIBDIR']
    obj.defines            = '_POSIX_C_SOURCE=200809L'

    if bld.env['build_target'] == 'mingw':
        obj.source         = 'windows/hid.c'
        obj.linkflags      = [ '-lsetupapi', '-mwindows' ]
        obj.uselib         = 'SETUPAPI'
    else:
        obj.cflags        += [ bld.env['compiler_flags_dict']['pic'] ]
        if sys.platform == 'darwin':
            obj.source     = 'mac/hid.c'
            obj.framework  = [ 'IOKit', 'CoreFoundation' ]
        else:
            obj.source     = 'linux/hid.c'
            if re.search ("linux", sys.platform) != None:
                obj.uselib = 'UDEV'

=== libs/lua/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf

I18N_PACKAGE = 'liblua'

def options(opt):
    pass

def configure(conf):
    pass

def build(bld):
    obj=bld.stlib (source   = ['lua.cc', 'luastate.cc'],
                   cflags   = [ bld.env['compiler_flags_dict']['pic'] ],
                   cxxflags = [ bld.env['compiler_flags_dict']['pic'] ],
                   includes = ['.'],
                   export_includes = ['.'],
                   target = 'liblua',
                   uselib = [ 'SIGCPP', 'DL' ]
               )
    autowaf.ensure_visible_symbols (obj, True)

=== debian/changelog ===
ardour (1:8.12.0+ds-2) unstable; urgency=medium

  [ Olivier Humbert ]
  * d/copyright: update my email address
  * d/rules: update my email address

  [ Alexandre Detiste ]
  * Remove obsolete dh-buildinfo build dependency

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Fix spelling mistakes in d/changelog
  * Disable salsa-ci (allow manual pipelines)
  * Update license data

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 28 Aug 2025 15:57:46 +0200

ardour (1:8.12.0+ds-1) unstable; urgency=medium

  * New upstream version 8.12.0+ds
  * Bump C++-standard to C++17 to fix FTBFS
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 16 Mar 2025 23:10:02 +0100

ardour (1:8.10.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Rebuild against taglib 2.0.2.
  * debian/control: Update build-dependency package name:
    + libtag1-dev => libtag-dev.

 -- Boyuan Yang <byang@debian.org>  Fri, 10 Jan 2025 22:05:35 -0500

=== debian/control ===
Source: ardour
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Dennis Braun <d_braun@kabelmail.de>,
Build-Depends:
 debhelper-compat (= 13),
 gettext,
 intltool,
 itstool,
# TODO: get rid of vendoring
 ladspa-sdk,
 libarchive-dev,
 libasound2-dev [linux-any],
 libaubio-dev,
 libboost-dev,
 libcairomm-1.0-dev,
 libcurl4-gnutls-dev,
 libcwiid-dev [linux-any],
 libdbus-1-dev,
 libfftw3-dev,
 libfluidsynth-dev,
 libglibmm-2.4-dev,
 libhidapi-dev,
 libjack-dev,
 liblilv-dev,
 liblo-dev,
 liblrdf0-dev,
 libltc-dev,
 libpangomm-1.4-dev,
 libpulse-dev,
 libqm-dsp-dev,
 libreadline-dev,
 librubberband-dev,
 libsamplerate0-dev,
 libsigc++-2.0-dev,
 libsndfile1-dev,
# TODO: get rid of vendoring
 libsuil-dev,
 libtag-dev,
 libusb-1.0-0-dev,
 libwebsockets-dev,
 libxinerama-dev,
 libxrandr-dev,
 lv2-dev,
 python3,
 vamp-plugin-sdk,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://ardour.org
Vcs-Git: https://salsa.debian.org/multimedia-team/ardour.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ardour

Package: ardour
Architecture: any
Depends:
 ardour-data (<< ${source:Upstream-Version}.0~),
 ardour-data (>= ${source:Version}),
 ardour-lv2-plugins (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ardour-video-timeline,
Suggests:
 ${shlibs:Suggests},
Replaces:
 ardour3 (<< 1:3.5),
Breaks:
 ardour3 (<< 1:3.5),
Description: the digital audio workstation
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 Ardour supports pro-audio interfaces
 through the ALSA project, which provides high quality, well designed
 device drivers and API's for audio I/O under Linux. Any interface
 supported by ALSA can be used with Ardour. This includes the
 all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples
 using floating point internally, non-linear editing with unlimited undo,
 a user-configurable mixer, MTC master/slave capabilities, MIDI hardware
 control surface compatibility.
 .
 It supports MIDI
 Machine Control, and so can be controlled from any MMC controller and
 many modern digital mixers.
 .
 Ardour contains a
 powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing
 operations (insert, replace, delete, move, trim, select,
 cut/copy/paste). The editor has unlimited undo/redo capabilities and can
 save independent "versions" of a track or an entire piece
 .
 Ardour's editor supports the community-developed LADSPA
 plugin standard.  Arbitrary chains of plugins can be attached to any
 portion of a track.  Every mixer strip can have any number of inputs
 and outputs, not just mono, stereo or 5.1.  An N-way panner is
 included, with support for various panning models.  Pre- and post-fader
 sends exist, each with their own gain and pan controls.  Every mixer
 strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another
 strip.
 .
 Ardour's channel capacity is limited only
 by the number on your audio interface and the ability of your disk
 subsystem to stream the data back and forth.
 .
 JACK
 (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications
 and/or hardware audio interfaces.
 .
 Ardour is
 sample rate and size neutral - any hardware formats from 8 to 32 bits,
 and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be
 found at <https://ardour.org/>.

Package: ardour-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 ardour,
Breaks:
 ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Replaces:
 ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Description: digital audio workstation (data)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This package contains the architecture-independent data files.

Package: ardour-video-timeline
Architecture: all
Multi-Arch: foreign
Depends:
 ffmpeg (>= 7:1.2),
 harvid (>= 0.7.0),
 xjadeo (>= 0.6.4),
 ${misc:Depends},
Description: digital audio workstation - video timeline
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This is a dependency package to add video timeline capabilities to ardour.

Package: ardour-lv2-plugins
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lv2-plugin,
Description: digital audio workstation - lv2 plugins set
 Ardour is providing a set of LV2 plugins:
  * a-comp.lv2
    - a compressor (mono & stereo versions)
  * a-exp.lv2
    - an expander (mono & stereo versions)
  * a-delay.lv2
    - a delay (mono version)
  * a-eq.lv2
    - an equaliser (mono version)
  * a-reverb.lv2
    - a reverberation (stereo version)
  * a-fluidsynth.lv2
    - a SF2 player (stereo version)
  * reasonablesynth.lv2
    - a reasonably good piano synth (stereo version)
 .
 This package allows these to be used by other hosts as well.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
# © 2019, IOhannes m zmölnig <umlaeute@debian.org>
# © 2020, Olivier Humbert <trebmuh@librazik.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
BUILD_DATE:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" +"%F")

# Ardour uses some c++11 features requiring atomic_load_8 and
# probably more, so we need to link with libatomic on
# armel, powerpc, powerpcspe, m68k, mips, mipsel, sh4, ...
# see also:
# - https://gcc.gnu.org/wiki/Atomic
# - https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
# - packaging for 'clasp', 'juce',...
# link with libatomic on architectures without built-in atomic
ifneq ($(strip $(filter $(DEB_HOST_ARCH), armel powerpc powerpcspe m68k mips mipsel sh4 riscv64)),)
        LDFLAGS += -latomic
endif

ifeq ($(DEB_HOST_ARCH), mips64el)
        CXXFLAGS += -mxgot
endif

ifneq (,$(filter $(DEB_HOST_ARCH), mipsel sh4))
        CXXFLAGS += -g1
endif

########### WAF options ############
waf-light = python3 $(CURDIR)/debian/waf/waf-light
waf-configure-options = \
	--freedesktop \
	--configdir=/etc/ \
	--noconfirm \
	--prefix=/usr/ \
	--libjack=weak \
	--no-phone-home \
	--use-external-libs \
	--optimize \
	--cxx17 \
	--ptformat \
	--lv2dir=/usr/lib/lv2 \
	$(empty)


DIST_TARGET = none
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	DIST_TARGET = i686
endif
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	DIST_TARGET = x86_64
endif

BACKENDS = jack,dummy
ifneq (,$(findstring linux,$(DEB_HOST_ARCH_OS)))
# ALSA Backend is only available on Linux
	BACKENDS = jack,alsa,dummy,pulseaudio
else
	waf-configure-options += \
		--no-fpu-optimization \
		$(empty)
endif

ARDOUR_LIBRARY_PATH := /usr/lib/ardour8/

waf-configure-options += \
	--with-backends=$(BACKENDS) \
	--dist-target=$(DIST_TARGET) \
	$(empty)

DEB_WAF_INVOKE = \
	CPPFLAGS="$(CPPFLAGS)" \
	CFLAGS="$(CFLAGS)" \
	CXXFLAGS="$(CXXFLAGS)" \
	LDFLAGS="$(LDFLAGS) -Wl,--as-needed" \
	$(waf-light) -v --destdir=$(CURDIR)/debian/tmp

deb_revision := libs/ardour/revision.cc
waf_extras := debian/waf/waflib/extras/autowaf.py debian/waf/waflib/extras/misc.py

########### build overrides options ############
%:
	dh $@

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: ^\[[ 0-9]+/[ 0-9]+\] Compiling .*"

override_dh_auto_build: genfiles
	$(DEB_WAF_INVOKE) configure $(waf-configure-options)
	$(DEB_WAF_INVOKE) build i18n_mo

override_dh_auto_install: override_dh_auto_build manpages genfiles
	$(DEB_WAF_INVOKE) install
	for res in 16 22 32 48; do \
		mkdir -p $(CURDIR)/debian/ardour/usr/share/icons/hicolor/$${res}x$${res}/mimetypes; \
		cp $(CURDIR)/gtk2_ardour/icons/application-x-ardour_$${res}px.png \
			$(CURDIR)/debian/ardour/usr/share/icons/hicolor/$${res}x$${res}/mimetypes/application-x-ardour.png ; \
	done

## ardour includes a couple of private lib*.so files, which make
## dh_makeshlibs emit a useless call to `ldconfig` in the postinst script.
## since we don't have any public libraries, we just suppress that call.
override_dh_makeshlibs:
	dh_makeshlibs --no-scripts
override_dh_shlibdeps:
	dh_shlibdeps -- -l$(CURDIR)/debian/ardour/$(ARDOUR_LIBRARY_PATH)

execute_before_dh_clean: manpageclean
	find . -name "*.pyc" -delete || true
	find . -name "*.mo" -delete || true

########### build intermediates ############
.PHONY: genfiles
genfiles: $(deb_revision) $(waf_extras)

$(deb_revision):
	echo '#include "ardour/revision.h"' > $@
	echo "namespace ARDOUR { const char* revision = \"$(subst +,~,$(DEB_VERSION_UPSTREAM_REVISION))\"; const char* date = \"$(BUILD_DATE)\"; }" >> $@

debian/waf/waflib/extras/%: tools/%
	cp $< $@

MANPAGES = ardour8-copy-mixer.1 \
	ardour8-export.1 \
	ardour8-new_empty_session.1 \
	ardour8-new_session.1 \
	ardour8-lua.1 \
	$(empty)
.PHONY: manpages manpageclean
$(MANPAGES): debian/ardour-utils.1
	cp $^ $@
manpages: $(MANPAGES)
manpageclean:
	rm -f $(MANPAGES)

################ d/copyright helper ##############
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|.*\.ico|.*\.icns|.*\.png|.*\.xcf|.*\.wav|.*\.flac|.*\.ogg|.*\.touchosc|.*\.tosc|.*\.pdf|.*\.woff
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints
